C***********************************************************************
c*SSWAP -- Swap two vectors.
c:BLAS
c+
      SUBROUTINE  SSWAP (N,SX,INCX,SY,INCY)
C
C     INTERCHANGES TWO VECTORS.
C     USES UNROLLED LOOPS FOR INCREMENTS EQUAL TO 1.
C     JACK DONGARRA, LINPACK, 3/11/78.
C
C--
      REAL SX(1),SY(1),STEMP
      INTEGER I,INCX,INCY,IX,IY,M,MP1,N
C
      IF(N.LE.0)RETURN
      IF(INCX.EQ.1.AND.INCY.EQ.1)GO TO 20
C
C	CODE FOR UNEQUAL INCREMENTS OR EQUAL INCREMENTS NOT EQUAL
C	  TO 1
C
      IX = 1
      IY = 1
      IF(INCX.LT.0)IX = (-N+1)*INCX + 1
      IF(INCY.LT.0)IY = (-N+1)*INCY + 1
      DO 10 I = 1,N
	STEMP = SX(IX)
	SX(IX) = SY(IY)
	SY(IY) = STEMP
	IX = IX + INCX
	IY = IY + INCY
   10 CONTINUE
      RETURN
C
C	CODE FOR BOTH INCREMENTS EQUAL TO 1
C
C
C	CLEAN-UP LOOP
C
   20 M = MOD(N,3)
      IF( M .EQ. 0 ) GO TO 40
      DO 30 I = 1,M
	STEMP = SX(I)
	SX(I) = SY(I)
	SY(I) = STEMP
   30 CONTINUE
      IF( N .LT. 3 ) RETURN
   40 MP1 = M + 1
      DO 50 I = MP1,N,3
	STEMP = SX(I)
	SX(I) = SY(I)
	SY(I) = STEMP
	STEMP = SX(I + 1)
	SX(I + 1) = SY(I + 1)
	SY(I + 1) = STEMP
	STEMP = SX(I + 2)
	SX(I + 2) = SY(I + 2)
	SY(I + 2) = STEMP
   50 CONTINUE
      RETURN
      END
